package com.sun.jmx.snmp.IPAcl;

import java.io.InputStreamReader;
import java.io.InputStream;
import java.io.IOException;
import java.io.Reader;

final class ASCII_CharStream
{
    public static final boolean staticFlag = false;
    int bufsize;
    int available;
    int tokenBegin;
    public int bufpos;
    private int[] bufline;
    private int[] bufcolumn;
    private int column;
    private int line;
    private boolean prevCharIsCR;
    private boolean prevCharIsLF;
    private Reader inputStream;
    private char[] buffer;
    private int maxNextCharInd;
    private int inBuf;
    
    private final void ExpandBuff(boolean b) {
        char[] array = new char[this.bufsize + 2048];
        int[] array2 = new int[this.bufsize + 2048];
        int[] array3 = new int[this.bufsize + 2048];
        try {
            if (b) {
                System.arraycopy(this.buffer, this.tokenBegin, array, 0, this.bufsize - this.tokenBegin);
                System.arraycopy(this.buffer, 0, array, this.bufsize - this.tokenBegin, this.bufpos);
                this.buffer = array;
                System.arraycopy(this.bufline, this.tokenBegin, array2, 0, this.bufsize - this.tokenBegin);
                System.arraycopy(this.bufline, 0, array2, this.bufsize - this.tokenBegin, this.bufpos);
                this.bufline = array2;
                System.arraycopy(this.bufcolumn, this.tokenBegin, array3, 0, this.bufsize - this.tokenBegin);
                System.arraycopy(this.bufcolumn, 0, array3, this.bufsize - this.tokenBegin, this.bufpos);
                this.bufcolumn = array3;
                int n2 = this.bufpos + (this.bufsize - this.tokenBegin);
                this.bufpos = n2;
                this.maxNextCharInd = n2;
            }
            else {
                System.arraycopy(this.buffer, this.tokenBegin, array, 0, this.bufsize - this.tokenBegin);
                this.buffer = array;
                System.arraycopy(this.bufline, this.tokenBegin, array2, 0, this.bufsize - this.tokenBegin);
                this.bufline = array2;
                System.arraycopy(this.bufcolumn, this.tokenBegin, array3, 0, this.bufsize - this.tokenBegin);
                this.bufcolumn = array3;
                int n = this.bufpos - this.tokenBegin;
                this.bufpos = n;
                this.maxNextCharInd = n;
            }
        }
        catch (Throwable t) {
            throw new Error(t.getMessage());
        }
        this.bufsize += 2048;
        this.available = this.bufsize;
        this.tokenBegin = 0;
    }
    
    private final void FillBuff() throws IOException {
        if (this.maxNextCharInd == this.available) {
            if (this.available == this.bufsize) {
                if (this.tokenBegin > 2048) {
                    int n2 = 0;
                    this.maxNextCharInd = n2;
                    this.bufpos = n2;
                    this.available = this.tokenBegin;
                }
                else if (this.tokenBegin < 0) {
                    int n = 0;
                    this.maxNextCharInd = n;
                    this.bufpos = n;
                }
                else {
                    this.ExpandBuff(false);
                }
            }
            else if (this.available > this.tokenBegin) {
                this.available = this.bufsize;
            }
            else if (this.tokenBegin - this.available < 2048) {
                this.ExpandBuff(true);
            }
            else {
                this.available = this.tokenBegin;
            }
        }
        try {
            int read;
            if ((read = this.inputStream.read(this.buffer, this.maxNextCharInd, this.available - this.maxNextCharInd)) == -1) {
                this.inputStream.close();
                throw new IOException();
            }
            this.maxNextCharInd += read;
            return;
        }
        catch (IOException ex) {
            --this.bufpos;
            this.backup(0);
            if (this.tokenBegin == -1) {
                this.tokenBegin = this.bufpos;
            }
            throw ex;
        }
    }
    
    public final char BeginToken() throws IOException {
        this.tokenBegin = -1;
        int char1 = this.readChar();
        this.tokenBegin = this.bufpos;
        return char1;
    }
    
    private final void UpdateLineColumn(char c) {
        ++this.column;
        if (this.prevCharIsLF) {
            this.prevCharIsLF = false;
            int line2 = this.line;
            int column2 = 1;
            this.column = column2;
            this.line = line2 + column2;
        }
        else if (this.prevCharIsCR) {
            this.prevCharIsCR = false;
            if (c == '\n') {
                this.prevCharIsLF = true;
            }
            else {
                int line = this.line;
                int column = 1;
                this.column = column;
                this.line = line + column;
            }
        }
        switch (c) {
            case '\r': {
                this.prevCharIsCR = true;
                break;
            }
            case '\n': {
                this.prevCharIsLF = true;
                break;
            }
            case '\t': {
                --this.column;
                this.column += 8 - (this.column & 0x7);
                break;
            }
        }
        this.bufline[this.bufpos] = this.line;
        this.bufcolumn[this.bufpos] = this.column;
    }
    
    public final char readChar() throws IOException {
        if (this.inBuf > 0) {
            --this.inBuf;
            return (char)('ÿ' & this.buffer[(this.bufpos == this.bufsize - 1) ? (this.bufpos = 0) : (++this.bufpos)]);
        }
        if (++this.bufpos >= this.maxNextCharInd) {
            this.FillBuff();
        }
        int n = (char)('ÿ' & this.buffer[this.bufpos]);
        this.UpdateLineColumn((char)n);
        return n;
    }
    
    @Deprecated
    public final int getColumn() {
        return this.bufcolumn[this.bufpos];
    }
    
    @Deprecated
    public final int getLine() {
        return this.bufline[this.bufpos];
    }
    
    public final int getEndColumn() {
        return this.bufcolumn[this.bufpos];
    }
    
    public final int getEndLine() {
        return this.bufline[this.bufpos];
    }
    
    public final int getBeginColumn() {
        return this.bufcolumn[this.tokenBegin];
    }
    
    public final int getBeginLine() {
        return this.bufline[this.tokenBegin];
    }
    
    public final void backup(int n) {
        this.inBuf += n;
        int bufpos = this.bufpos - n;
        this.bufpos = bufpos;
        if (bufpos < 0) {
            this.bufpos += this.bufsize;
        }
    }
    
    public ASCII_CharStream(Reader inputStream, int line, int n, int n2) {
        this.bufpos = -1;
        this.column = 0;
        this.line = 1;
        this.prevCharIsCR = false;
        this.prevCharIsLF = false;
        this.maxNextCharInd = 0;
        this.inBuf = 0;
        this.inputStream = inputStream;
        this.line = line;
        this.column = n - 1;
        this.bufsize = n2;
        this.available = n2;
        this.buffer = new char[n2];
        this.bufline = new int[n2];
        this.bufcolumn = new int[n2];
    }
    
    public ASCII_CharStream(Reader reader, int n, int n2) {
        this(reader, n, n2, 4096);
    }
    
    public void ReInit(Reader inputStream, int line, int n, int n2) {
        this.inputStream = inputStream;
        this.line = line;
        this.column = n - 1;
        if (this.buffer == null || n2 != this.buffer.length) {
            this.bufsize = n2;
            this.available = n2;
            this.buffer = new char[n2];
            this.bufline = new int[n2];
            this.bufcolumn = new int[n2];
        }
        boolean b = false;
        this.prevCharIsCR = b;
        this.prevCharIsLF = b;
        int tokenBegin = 0;
        this.maxNextCharInd = tokenBegin;
        this.inBuf = tokenBegin;
        this.tokenBegin = tokenBegin;
        this.bufpos = -1;
    }
    
    public void ReInit(Reader reader, int n, int n2) {
        this.ReInit(reader, n, n2, 4096);
    }
    
    public ASCII_CharStream(InputStream in, int n, int n2, int n3) {
        this(new InputStreamReader(in), n, n2, 4096);
    }
    
    public ASCII_CharStream(InputStream inputStream, int n, int n2) {
        this(inputStream, n, n2, 4096);
    }
    
    public void ReInit(InputStream in, int n, int n2, int n3) {
        this.ReInit(new InputStreamReader(in), n, n2, 4096);
    }
    
    public void ReInit(InputStream inputStream, int n, int n2) {
        this.ReInit(inputStream, n, n2, 4096);
    }
    
    public final String GetImage() {
        if (this.bufpos >= this.tokenBegin) {
            return new String(this.buffer, this.tokenBegin, this.bufpos - this.tokenBegin + 1);
        }
        return new String(this.buffer, this.tokenBegin, this.bufsize - this.tokenBegin) + new String(this.buffer, 0, this.bufpos + 1);
    }
    
    public final char[] GetSuffix(int n) {
        char[] array = new char[n];
        if (this.bufpos + 1 >= n) {
            System.arraycopy(this.buffer, this.bufpos - n + 1, array, 0, n);
            return array;
        }
        System.arraycopy(this.buffer, this.bufsize - (n - this.bufpos - 1), array, 0, n - this.bufpos - 1);
        System.arraycopy(this.buffer, 0, array, n - this.bufpos - 1, this.bufpos + 1);
        return array;
    }
    
    public void Done() {
        this.buffer = null;
        this.bufline = null;
        this.bufcolumn = null;
    }
    
    public void adjustBeginLineColumn(int n, int n2) {
        int tokenBegin = this.tokenBegin;
        int n3;
        if (this.bufpos >= this.tokenBegin) {
            n3 = this.bufpos - this.tokenBegin + this.inBuf + 1;
        }
        else {
            n3 = this.bufsize - this.tokenBegin + this.bufpos + 1 + this.inBuf;
        }
        int n4 = 0;
        int n5 = 0;
        int n6 = 0;
        int n7;
        while (n4 < n3 && this.bufline[n5 = tokenBegin % this.bufsize] == this.bufline[n7 = ++tokenBegin % this.bufsize]) {
            this.bufline[n5] = n;
            int n8 = n6 + this.bufcolumn[n7] - this.bufcolumn[n5];
            this.bufcolumn[n5] = n2 + n6;
            n6 = n8;
            ++n4;
        }
        if (n4 < n3) {
            this.bufline[n5] = n++;
            this.bufcolumn[n5] = n2 + n6;
            while (n4++ < n3) {
                if (this.bufline[n5 = tokenBegin % this.bufsize] != this.bufline[++tokenBegin % this.bufsize]) {
                    this.bufline[n5] = n++;
                }
                else {
                    this.bufline[n5] = n;
                }
            }
        }
        this.line = this.bufline[n5];
        this.column = this.bufcolumn[n5];
    }
}
